/*	EPROTO:		Global function prototypes and declarations
			MicroEMACS 3.12

                        written by Daniel Lawrence
                        based on code by Dave G. Conroy,
                        	Steve Wilhite and George Jones
*/

#if	PROTO

/***	global function prototypes	***/

#if	WINDOW_MSWIN
extern char *fullpathname(char *PathName, int Nbuf);
extern int vtinitscr(SCREEN * sp, int nrow, int ncol);
extern int vtsizescr(SCREEN * sp, int nrow, int ncol);
extern int cutregion(int f, int n);
extern int clipregion(int f, int n);
extern int insertclip(int f, int n);
extern int helpengine(int f, int n);
extern int minimizescreen(int f, int n);
extern int maximizescreen(int f, int n);
extern int restorescreen(int f, int n);
extern int tilescreens(int f, int n);
extern int cascadescreens(int f, int n);
extern int bindtomenu(int f, int n);
extern int macrotomenu(int f, int n);
extern int unbindmenu(int f, int n);
extern int execmenu(int f, int n);
extern int longop(int f);
extern int filenamedlg(char *prompt, char *buf, int nbuf, int fullpath);
extern int vtfreescr(SCREEN * sp);
extern int unlist_screen(SCREEN * sp);
extern int mlhistory(void);
extern int updscrollbars(SCREEN * sp, char w_flag);
extern void vtscreen(SCREEN * sp);

#endif

#if CALLED
extern int emacs(int argc, char *argv[]);

#endif

extern BUFFER *bfind(char *bname, int cflag, int bflag);
extern BUFFER *getcbuf(char *prompt, char *defval, int createflag);
extern BUFFER *getdefb(void);

#if PREVBUF_CMD || DEFBUF_CURR
extern BUFFER *getlnkb(BUFFER * cbp, int step1st);

#endif

extern SCREEN *init_screen(char *, BUFFER *);
extern SCREEN *lookup_screen(char *scr_name);
extern SCREEN *index_screen(int scr_num);
extern int screen_index(SCREEN * sp);
extern int insert_screen(SCREEN * sp);
extern int select_screen(SCREEN * sp, int announce);
extern int free_screen(SCREEN * sp);
extern char *allocate(unsigned nbytes);
extern char *dolock(char *fname);
extern char *getpath(char *filespec);
extern char *gtname(char *filespec);
extern char *bytecopy(char *dst, char *src, int maxlen);
extern char *cmdstr(int c, char *seq);
extern char *copystr(char *);
extern char *mkprompt(char *, char *, int);
extern char *complete(char *prompt, char *defval, int type, int maxlen);
extern char *fixnull(char *s);
extern char *flook(char *fname, int hflag);
extern char *getctext(void);
extern char *getffile(char *fspec);
extern char *getfname(KEYTAB * key);
extern char *getkill(void);
extern char *getnfile(void);
extern char *getreg(char *value);
extern char *getval(char *token);
extern char *getwlist(char *buf);
extern char *gtenv(char *vname);
extern char *gtfilename(char *prompt);
extern char *gtfun(char *fname);
extern char *gtusr(char *vname);
extern char *int_asc(int i);
extern char *long_asc(long num);
extern char *ltos(int val);
extern char *makename(char *bname, char *fname);
extern char *mklower(char *str);
extern char *mkupper(char *str);
extern char *namval(int index);
extern char *timeset(void);

#if NEWVAR
extern char *getedate(void);

#endif
extern char *token(char *src, char *tok, int size);
extern char *transbind(char *skey);
extern char *trimstr(char *s);
extern char *xlat(char *source, char *lookup, char *trans);
extern char *undolock(char *fname);
extern char *regtostr(char *buf, REGION * region);
extern int lowerc(char ch);
extern int cycle_ring(int f, int n);
extern int upperc(char ch);

#if	ZTC || TURBO || IC
extern int (*  fncmatch(char *fname)) (int, int);
extern int (*  getname(char *prompt)) (int, int);

#else /* Sun (and others?) screwed up the prototyping.*/
extern int (*  fncmatch(char *fname)) (void);
extern int (*  getname(char *prompt)) (void);

#endif
extern int a1getc(FILE * fp);
extern int asc_int(char *st);
extern int comp_buffer(char *name, int *cpos);
extern int comp_command(char *name, int *cpos);

#if	!WINDOW_MSWIN
extern int comp_file(char *name, int *cpos);

#endif
extern int dolhello(void);
extern int dspram(void);
extern int lckerror(char *errstr);
extern int lckhello(void);
extern int xlock(char *fname);
extern int lockchk(char *fname);
extern int lockrel(void);
extern int mousehello(void);
extern int nocrypt(void);
extern int absv(int x);
extern int addline(BUFFER * bp, char *text);
extern int amatch(MC * mcptr, int direct, LINE ** pcwline, int *pcwoff);
extern int backhunt(int f, int n);
extern int backsearch(int f, int n);
extern int biteq(int bc, EBITMAP cclmap);
extern int bktoshell(int f, int n);
extern int boundry(LINE * curline, int curoff, int dir);
extern int cclmake(char **ppatptr, MC * mcptr);
extern int checknext(int chr, int dir);
extern int clear_ring(int f, int n);
extern int delins(int dlength, char *instr, int use_rmc);
extern int desfunc(int f, int n);
extern int dispvar(int f, int n);
extern int echochar(unsigned char c, int col);
extern int echostring(char *, int, int);
extern int eq(register unsigned char bc, register unsigned char pc);
extern long ernd(void);
extern int execkey(KEYTAB * key, int f, int n);
extern int fbound(int jump, LINE ** pcurline, int *pcuroff, int dir);
extern int fexist(char *fname);
extern int findcol(LINE * lp, int pos);
extern int fisearch(int f, int n);

#if	FLABEL
extern int fnclabel(int f, int n);

#endif
extern int forwhunt(int f, int n);
extern int forwsearch(int f, int n);
extern int getcwnum(void);
extern int getgoal(LINE * dlp);
extern int getstring(char *buf, int nbuf, int eolchar, int cmp_type);
extern int gettwnum(void);
extern int gettyp(char *token);
extern int getwpos(void);

#if	DBCS
extern int is2byte(char *sp, char *cp);

#endif
extern int isletter(register unsigned int ch);
extern int is_lower(register unsigned int ch);
extern int is_num(char *st);
extern int isearch(int dir);
extern int is_upper(register unsigned int ch);
extern int kinsert(int back, char c);
extern int ldelnewline(void);
extern int linstr(char *instr);
extern int lnewline(void);
extern int lookup_color(char *sp);
extern int lover(char *ostr);
extern int mceq(unsigned char bc, MC * mt);
extern int mcscanner(int direct, int beg_or_end, int repeats);
extern int mcstr(void);
extern int nextch(LINE ** pcurline, int *pcuroff, int dir);
extern int pop(BUFFER * popbuffer);
extern int qreplace(int f, int n);
extern int readpattern(char *prompt, char apat[], int srch);

#if	WINDOW_TEXT
extern void refresh_screen(SCREEN * sp);
#endif

extern int reglines(void);
extern int rename_screen(int f, int n);
extern int replaces(int kind, int f, int n);
extern int risearch(int f, int n);
extern int rmcstr(void);
extern int savematch(void);
extern int scanmore(int dir);
extern int scanner(int direct, int beg_or_end, int repeats);
extern int setlower(char *ch, char *val);
extern int setlower(char *ch, char *val);
extern int setupper(char *ch, char *val);
extern int setupper(char *ch, char *val);
extern int setvar(int f, int n);
extern int sindex(char *source, char *pattern);
extern int sreplace(int f, int n);
extern int stol(char *val);

#if	DBCS
extern int stopback(void);
extern int stopforw(void);

#endif
#if GNMARKS
extern int reset_nmark(LINE * lp, LINE * lpn);
extern int setnmark(int f, int n);
extern int jmpnmark(int f, int n);

#endif /* GNMARKS */
extern int svar(VDESC * var, char *value);
extern int tgetc(void);
extern int uneat(void);
extern int upscreen(int f, int n);
extern int vtinit(void);
extern int yank(int f, int n);
extern int yank_pop(int f, int n);
extern int release(char *mp);
extern int esetkey(KEYTAB * key, char *name);
extern int xunlock(char *fname);
extern KEYTAB *getbind(int c);
extern LINE *lalloc(int used);
extern LINE *mouseline(WINDOW * wp, int row);
extern long getlinenum(BUFFER * bp, LINE * sline);
extern int adjustmode(int kind, int global);
extern int anycb(void);
extern int apro(int f, int n);
extern int backchar(int f, int n);
extern int backdel(int f, int n);
extern int backline(int f, int n);
extern int backpage(register int f, register int n);
extern int backword(int f, int n);
extern int bclear(BUFFER * bp);
extern int binary(char *key, char *( * tval) (), int tlength);
extern int bindtokey(int f, int n);
extern int buildlist(int type, char *mstring);
extern int capword(int f, int n);
extern int cbuf(int f, int n, int bufnum);
extern int cbuf1(int f, int n);
extern int cbuf10(int f, int n);
extern int cbuf11(int f, int n);
extern int cbuf12(int f, int n);
extern int cbuf13(int f, int n);
extern int cbuf14(int f, int n);
extern int cbuf15(int f, int n);
extern int cbuf16(int f, int n);
extern int cbuf17(int f, int n);
extern int cbuf18(int f, int n);
extern int cbuf19(int f, int n);
extern int cbuf2(int f, int n);
extern int cbuf20(int f, int n);
extern int cbuf21(int f, int n);
extern int cbuf22(int f, int n);
extern int cbuf23(int f, int n);
extern int cbuf24(int f, int n);
extern int cbuf25(int f, int n);
extern int cbuf26(int f, int n);
extern int cbuf27(int f, int n);
extern int cbuf28(int f, int n);
extern int cbuf29(int f, int n);
extern int cbuf3(int f, int n);
extern int cbuf30(int f, int n);
extern int cbuf31(int f, int n);
extern int cbuf32(int f, int n);
extern int cbuf33(int f, int n);
extern int cbuf34(int f, int n);
extern int cbuf35(int f, int n);
extern int cbuf36(int f, int n);
extern int cbuf37(int f, int n);
extern int cbuf38(int f, int n);
extern int cbuf39(int f, int n);
extern int cbuf4(int f, int n);
extern int cbuf40(int f, int n);
extern int cbuf5(int f, int n);
extern int cbuf6(int f, int n);
extern int cbuf7(int f, int n);
extern int cbuf8(int f, int n);
extern int cbuf9(int f, int n);
extern int cex(int f, int n);

#if DIRH
extern chgdir(int f, int n);

#endif
extern int cinsert(void);
extern int clean(void);
extern int clrmes(int f, int n);
extern int copyregion(int f, int n);
extern int ctlxe(int f, int n);
extern int ctlxlp(int f, int n);
extern int ctlxrp(int f, int n);
extern int ctoec(int c);
extern int ctrlg(int f, int n);
extern int cycle_screens(int f, int n);
extern int dcline(int argc, char *argv[], int firstflag);
extern int deblank(int f, int n);
extern int debug(BUFFER * bp, char *eline, int *skipflag);
extern int delbword(int f, int n);
extern int delete_screen(int f, int n);
extern int delfword(int f, int n);
extern int delgmode(int f, int n);
extern int delmode(int f, int n);
extern int delwind(int f, int n);
extern int desbind(int f, int n);
extern int deskey(int f, int n);
extern int desvars(int f, int n);
extern int detab(int f, int n);
extern int dobuf(BUFFER * bp);
extern int docmd(char *cline);
extern int dofile(char *fname);
extern int ectoc(int c);
extern int edinit(char bname[]);
extern int editloop(void);
extern int endword(int f, int n);
extern int enlargewind(int f, int n);
extern int entab(int f, int n);
extern int execbuf(int f, int n);
extern int execcmd(int f, int n);
extern int execfile(int f, int n);
extern int execprg(int f, int n);
extern int execproc(int f, int n);
extern int execute(int c, int f, int n);

#if AUTOFILE_RO
extern int ffwtst(char *fname);

#endif
extern int ffclose(void);
extern int ffgetline(int *nbytes);
extern int ffputline(char buf[], int nbuf);
extern int ffropen(char *fn);
extern int ffwopen(char *fn, char *mode);
extern int fileapp(int f, int n);
extern int find_screen(int f, int n);
extern int filefind(int f, int n);
extern int filename(int f, int n);
extern int fileread(int f, int n);
extern int filesave(int f, int n);
extern int filewrite(int f, int n);
extern int fillpara(int f, int n);
extern int filter(int f, int n);
extern int findvar(char *var, VDESC * vd, int size);
extern int fmatch(char ch);
extern int forwchar(int f, int n);
extern int forwdel(int f, int n);
extern int forwline(int f, int n);
extern int forwpage(int f, int n);
extern int forwword(int f, int n);
extern int getccol(int bflg);
extern int getcmd(void);
extern int getfence(int f, int n);
extern int getfile(char fname[], int lockfl);
extern int getkey(void);
extern int getregion(REGION * rp);
extern int gotobob(int f, int n);
extern int gotobol(int f, int n);
extern int gotobop(int f, int n);
extern int gotoeob(int f, int n);
extern int gotoeol(int f, int n);
extern int gotoeop(int f, int n);
extern int gotoline(int f, int n);
extern int gotomark(int f, int n);
extern int help(int f, int n);
extern int ifile(char fname[]);
extern int indent(int f, int n);
extern int indent_region(int f, int n);
extern int insbrace(int n, int c);
extern int insfile(int f, int n);
extern int inspound(void);
extern int insspace(int f, int n);
extern int inword(void);
extern int ismodeline(WINDOW * wp, int row);
extern int istring(int f, int n);
extern int killbuffer(int f, int n);
extern int killpara(int f, int n);
extern int killregion(int f, int n);
extern int killtext(int f, int n);
extern int lchange(register int flag);
extern int ldelete(long n, int kflag);
extern int lfree(LINE * lp);
extern int linsert(int n, char c);
extern int listbuffers(int f, int n);
extern int list_screens(int f, int n);
extern int lowerregion(int f, int n);
extern int lowerword(int f, int n);
extern int lowrite(char c);
extern int macarg(char *tok);
extern int macrotokey(int f, int n);
extern int makelist(int iflag);
extern int mouse_screen(void);
extern int screenlist(int iflag);
extern int meexit(int status);
extern int meta(int f, int n);
extern int mlreply(char *prompt, char *buf, int nbuf);
extern int mlyesno(char *prompt);
extern int mouseoffset(WINDOW * wp, LINE * lp, int col);
extern int movemd(int f, int n);
extern int movemu(int f, int n);
extern int mregdown(int f, int n);
extern int mmove(int f, int n);
extern int mregup(int f, int n);
extern int mvdnwind(int f, int n);
extern int mvupwind(int f, int n);
extern int namebuffer(int f, int n);
extern int namedcmd(int f, int n);
extern int narrow(int f, int n);
extern int newline(int f, int n);
extern int new_col_org(int f, int n);
extern int new_row_org(int f, int n);
extern int newsize(int f, int n);
extern int newwidth(int f, int n);
extern int nextarg(char *prompt, char *buffer, int size, int terminator);
extern int nextbuffer(int f, int n);

#if PREVBUF_CMD
extern int prevbuffer(int f, int n);

#endif
extern int nextdown(int f, int n);
extern int nextup(int f, int n);
extern int nextwind(int f, int n);
extern int nullproc(int f, int n);
extern int onlywind(int f, int n);
extern int openline(int f, int n);
extern int ostring(char *s);
extern int outstring(char *s);
extern int ovstring(int f, int n);
extern int pipecmd(int f, int n);
extern int popbuffer(int f, int n);
extern int prevwind(int f, int n);
extern int putctext(char *iline);
extern int putline(int row, int col, char buf[]);
extern int quickexit(int f, int n);
extern int quit(int f, int n);
extern int quote(int f, int n);
extern int rdonly(void);
extern int readin(char fname[], int lockfl);
extern int reform(char *para);
extern int refresh(int f, int n);
extern int remmark(int f, int n);
extern int reposition(int f, int n);
extern int resetkey(void);
extern int resize(int f, int n);
extern int resizm(int f, int n);
extern int resterr(void);
extern int restwnd(int f, int n);
extern int savewnd(int f, int n);
extern int scwrite(int row, char *outstr, int forg, int bacg,
			       int revleft, int revright);
extern int setccol(int pos);
extern int setekey(int f, int n);
extern int setfillcol(int f, int n);
extern int setgmode(int f, int n);
extern int setmark(int f, int n);
extern int setmod(int f, int n);
extern int setwlist(char *wclist);
extern int shellprog(char *cmd);
extern int showcpos(int f, int n);
extern int showfiles(int f, int n);
extern int shrinkwind(int f, int n);
extern int spal(char *pstr);
extern int spawn(int f, int n);
extern int spawncli(int f, int n);
extern int splitwind(int f, int n);
extern int startup(char *sfname);
extern int storemac(int f, int n);
extern int storeproc(int f, int n);
extern int strinc(char *source, char *sub);
extern int swapmark(int f, int n);
extern int swbuffer(BUFFER * bp);
extern int tab(int f, int n);
extern int trim(int f, int n);
extern int ttclose(void);
extern int ttflush(void);
extern int ttgetc(void);
extern int ttopen(void);
extern int ttputc(int c);
extern int twiddle(int f, int n);
extern int typahead(void);
extern int unarg(void);
extern int unbindchar(int c);
extern int unbindkey(int f, int n);
extern int undent_region(int f, int n);
extern int unmark(int f, int n);
extern int upperregion(int f, int n);
extern int upperword(int f, int n);
extern int usebuffer(int f, int n);
extern int viewfile(int f, int n);
extern int vteeol(void);
extern int vtmove(int row, int col);
extern int vtputc(int c);
extern int vttidy(void);
extern int widen(int f, int n);
extern int wordcount(int f, int n);
extern int wrapword(int f, int n);
extern int writemsg(int f, int n);
extern int writeout(char *fn, char *mode);
extern int zotbuf(BUFFER * bp);
extern unsigned int chcase(register unsigned int ch);
extern unsigned int getckey(int mflag);
extern unsigned int stock(char *keyname);

#if	VARARG && VARG
#if	GCC
extern void mlwrite(va_alist);

#else
extern void mlwrite(va_dcl

);
#endif /* GCC */
#else
extern void mlwrite(char *fmt,...);

#endif
extern void crypt(char *bptr, unsigned len);
extern void errormesg(char *mesg, BUFFER * bp, LINE * lp);
extern void flong_asc(char buf[], int width, long num);
extern void freewhile(WHBLOCK * wp);
extern void getdtime(char *ts);
extern void initchars(void);
extern void kdelete(void);
extern void lowercase(unsigned char *cp);
extern void makelit(char *s);
extern void mcclear(void);
extern void mlabort(char *s);
extern void mlerase(void);
extern void mlferase(void);
extern void mlforce(char *s);
extern void mlout(int c);
extern void mlputf(int s);
extern void mlputi(int i, int r);
extern void mlputli(long l, int r);
extern void mlputs(char *s);
extern void mlrquery(void);
extern void modeline(WINDOW * wp);
extern void movecursor(int row, int col);
extern void next_kill(void);
extern void pad(char *s, int len);
extern void reeat(int c);
extern void reframe(WINDOW * wp);
extern void rmcclear(void);
extern void setbit(int bc, EBITMAP cclmap);
extern void setjtable(void);
extern void unqname(char *name);
extern void updall(WINDOW * wp);
extern void update(int force);
extern void update_size(void);
extern void upddex(void);
extern void updext(void);
extern void updgar(void);
extern void updone(WINDOW * wp);
extern void updpos(void);
extern void updupd(int force);
extern void upmode(void);
extern void uppercase(unsigned char *cp);
extern void upwind(void);
extern void varinit(void);
extern void varclean(void);
extern void vtfree(void);
extern WINDOW *mousewindow(int row);
extern int wpopup(BUFFER * popbuf);

#if	CTAGS
extern int tagword(int f, int n);	/* vi-like tagging */
extern int retagword(int f, int n);	/* Try again (if redefined) */
extern int backtagword(int f, int n);	/* return from tagged word */

#endif

#if LINE_FNS
extern int copyline(int f, int n);
extern int kill_line(int f, int n);
extern int openabove(int f, int n);

#endif

/* some library redefinitions */

char *strrev(char *);

#if WINNT || WINDOW_MSWIN || (MSDOS && IC) || GCC || VMS || UNIX
#include <stdlib.h>
#include <string.h>
#else
char *strcat(char *, char *);
char *strcpy(char *, char *);
int strlen(char *);
int strncmp(char *, char *, int);
char *strchr(char *, int);
int strcmp(char *, char *);
char *realloc(char *block, int siz);

#if RAMSIZE == 0
char *malloc(int);
VOID free(char *);
#endif  /* RAMSIZE */
#endif

#if UNDOCMD
extern int  undump(int f, int n);
extern int  undebug(int f, int n);
extern int  undo(int f, int n);
extern int  undo_finished(int f, int n);
extern int  undo_gotomark(int f, int n);
extern int  undo_linsert(int f, int n);
extern int  undo_newline(int f, int n);
extern int  fix_undo_struct(LINE *lp1, LINE *lp2);
extern int  undo_ldelete(int f, int n);
extern int  undo_save_ldelete(int f, int n, char *cp1, char *cp2);
extern int  undo_ifile(int f, int n);
extern int  undo_save_dot(int f, int n);
extern int  undo_save_fn(int f,int  n,int ( *save_fn)());
#endif

#else

/***	global function declarations	***/
#if CALLED
extern int emacs();

#endif

extern BUFFER *bfind();
extern BUFFER *getcbuf();
extern BUFFER *getdefb();

#if PREVBUF_CMD || DEFBUF_CURR
extern BUFFER *getlnkb();

#endif

extern SCREEN *init_screen();
extern SCREEN *lookup_screen();
extern SCREEN *index_screen();
extern int screen_index();
extern int insert_screen();
extern int select_screen();
extern int free_screen();
extern char *allocate();
extern char *dolock();
extern char *getpath();
extern char *gtname();
extern char *bytecopy();
extern char *cmdstr();
extern char *copystr();
extern char *mkprompt();
extern char *complete();
extern char *fixnull();
extern char *flook();
extern char *getctext();
extern char *getffile();
extern char *getfname();
extern char *getkill();
extern char *getnfile();
extern char *getreg();
extern char *getval();
extern char *getwlist();
extern char *gtenv();
extern char *gtfilename();
extern char *gtfun();
extern char *gtusr();
extern char *int_asc();
extern char *long_asc();
extern char *ltos();
extern char *makename();
extern char *mklower();
extern char *mkupper();
extern char *namval();
extern char *timeset();

#if NEWVAR
extern char *getedate();

#endif
extern char *token();
extern char *transbind();
extern char *trimstr();
extern char *xlat();
extern char *undolock();
extern char *regtostr();
extern int lowerc();
extern int upperc();
extern int (* fncmatch()) ();
extern int (* getname()) ();
extern int a1getc();
extern int asc_int();
extern int comp_buffer();
extern int comp_command();
extern int comp_file();
extern int dolhello();
extern int dspram();
extern int lckerror();
extern int lckhello();
extern int xlock();
extern int lockchk();
extern int lockrel();
extern int mousehello();
extern int nocrypt();
extern int absv();
extern int addline();
extern int amatch();
extern int backhunt();
extern int backsearch();
extern int biteq();
extern int bktoshell();
extern int boundry();
extern int cclmake();
extern int checknext();
extern int clear_ring();
extern int cycle_ring();
extern int delins();
extern int desfunc();
extern int dispvar();
extern int echochar();
extern int echostring();
extern int eq();
extern long ernd();
extern int execkey();
extern int fbound();
extern int fexist();
extern int findcol();
extern int fisearch();

#if	FLABEL
extern int fnclabel();

#endif
extern int forwhunt();
extern int forwsearch();
extern int getcwnum();
extern int getgoal();
extern int getstring();
extern int gettwnum();
extern int gettyp();
extern int getwpos();

#if	DBCS
extern int is2byte();

#endif
extern int isletter();
extern int is_lower();
extern int is_num();
extern int isearch();
extern int is_upper();
extern int kinsert();
extern int ldelnewline();
extern int linstr();
extern int lnewline();
extern int lookup_color();
extern int lover();
extern int mceq();
extern int mcscanner();
extern int mcstr();
extern int nextch();
extern int pop();
extern int qreplace();
extern int readpattern();

#if	WINDOW_TEXT
extern void refresh_screen();

#endif
extern int reglines();
extern int rename_screen();
extern int replaces();
extern int risearch();
extern int rmcstr();
extern int savematch();
extern int scanmore();
extern int scanner();
extern int setlower();
extern int setlower();
extern int setupper();
extern int setupper();
extern int setvar();
extern int sindex();
extern int sreplace();
extern int stol();

#if	DBCS
extern int stopback();
extern int stopforw();

#endif
#if GNMARKS
extern int reset_nmark();
extern int setnmark();
extern int jmpnmark();

#endif /* GNMARKS */
extern int svar();
extern int tgetc();
extern int uneat();
extern int upscreen();
extern int vtinit();
extern int yank();
extern int yank_pop();
extern int release();
extern int esetkey();
extern int xunlock();
extern KEYTAB *getbind();
extern LINE *lalloc();
extern LINE *mouseline();
extern long getlinenum();
extern int adjustmode();
extern int anycb();
extern int apro();
extern int backchar();
extern int backdel();
extern int backline();
extern int backpage();
extern int backword();
extern int bclear();
extern int binary();
extern int bindtokey();
extern int buildlist();
extern int capword();
extern int cbuf();
extern int cbuf1();
extern int cbuf10();
extern int cbuf11();
extern int cbuf12();
extern int cbuf13();
extern int cbuf14();
extern int cbuf15();
extern int cbuf16();
extern int cbuf17();
extern int cbuf18();
extern int cbuf19();
extern int cbuf2();
extern int cbuf20();
extern int cbuf21();
extern int cbuf22();
extern int cbuf23();
extern int cbuf24();
extern int cbuf25();
extern int cbuf26();
extern int cbuf27();
extern int cbuf28();
extern int cbuf29();
extern int cbuf3();
extern int cbuf30();
extern int cbuf31();
extern int cbuf32();
extern int cbuf33();
extern int cbuf34();
extern int cbuf35();
extern int cbuf36();
extern int cbuf37();
extern int cbuf38();
extern int cbuf39();
extern int cbuf4();
extern int cbuf40();
extern int cbuf5();
extern int cbuf6();
extern int cbuf7();
extern int cbuf8();
extern int cbuf9();
extern int cex();

#if DIRH
extern chgdir();

#endif
extern int cinsert();
extern int clean();
extern int clrmes();
extern int copyregion();
extern int ctlxe();
extern int ctlxlp();
extern int ctlxrp();
extern int ctoec();
extern int ctrlg();
extern int cycle_screens();
extern int dcline();
extern int deblank();
extern int debug();
extern int delbword();
extern int delete_screen();
extern int delfword();
extern int delgmode();
extern int delmode();
extern int delwind();
extern int desbind();
extern int deskey();
extern int desvars();
extern int detab();
extern int dobuf();
extern int docmd();
extern int dofile();
extern int ectoc();
extern int edinit();
extern int editloop();
extern int endword();
extern int enlargewind();
extern int entab();
extern int execbuf();
extern int execcmd();
extern int execfile();
extern int execprg();
extern int execproc();
extern int execute();

#if AUTOFILE_RO
extern int ffwtst();

#endif
extern int ffclose();
extern int ffgetline();
extern int ffputline();
extern int ffropen();
extern int ffwopen();
extern int fileapp();
extern int find_screen();
extern int filefind();
extern int filename();
extern int fileread();
extern int filesave();
extern int filewrite();
extern int fillpara();
extern int filter();
extern int findvar();
extern int fmatch();
extern int forwchar();
extern int forwdel();
extern int forwline();
extern int forwpage();
extern int forwword();
extern int getccol();
extern int getcmd();
extern int getfence();
extern int getfile();
extern int getkey();
extern int getregion();
extern int gotobob();
extern int gotobol();
extern int gotobop();
extern int gotoeob();
extern int gotoeol();
extern int gotoeop();
extern int gotoline();
extern int gotomark();
extern int help();
extern int ifile();
extern int indent();
extern int indent_region();
extern int insbrace();
extern int insfile();
extern int inspound();
extern int insspace();
extern int inword();
extern int ismodeline();
extern int istring();
extern int killbuffer();
extern int killpara();
extern int killregion();
extern int killtext();
extern int lchange();
extern int ldelete();
extern int lfree();
extern int linsert();
extern int listbuffers();
extern int list_screens();
extern int lowerregion();
extern int lowerword();
extern int lowrite();
extern int macarg();
extern int macrotokey();
extern int makelist();
extern int mouse_screen();
extern int screenlist();
extern int meexit();
extern int meta();
extern int mlreply();
extern int mlyesno();
extern int mouseoffset();
extern int movemd();
extern int movemu();
extern int mregdown();
extern int mmove();
extern int mregup();
extern int mvdnwind();
extern int mvupwind();
extern int namebuffer();
extern int namedcmd();
extern int narrow();
extern int newline();
extern int new_col_org();
extern int new_row_org();
extern int newsize();
extern int newwidth();
extern int nextarg();
extern int nextbuffer();

#if PREVBUF_CMD
extern int prevbuffer();

#endif
extern int nextdown();
extern int nextup();
extern int nextwind();
extern int nullproc();
extern int onlywind();
extern int openline();
extern int ostring();
extern int outstring();
extern int ovstring();
extern int pipecmd();
extern int popbuffer();
extern int prevwind();
extern int putctext();
extern int putline();
extern int quickexit();
extern int quit();
extern int quote();
extern int rdonly();
extern int readin();
extern int reform();
extern int refresh();
extern int remmark();
extern int reposition();
extern int resetkey();
extern int resize();
extern int resizm();
extern int resterr();
extern int restwnd();
extern int savewnd();
extern int scwrite();
extern int setccol();
extern int setekey();
extern int setfillcol();
extern int setgmode();
extern int setmark();
extern int setmod();
extern int setwlist();
extern int shellprog();
extern int showfiles();
extern int showcpos();
extern int shrinkwind();
extern int spal();
extern int spawn();
extern int spawncli();
extern int splitwind();
extern int startup();
extern int storemac();
extern int storeproc();
extern int strinc();
extern int swapmark();
extern int swbuffer();
extern int tab();
extern int trim();
extern int ttclose();
extern int ttflush();
extern int ttgetc();
extern int ttopen();
extern int ttputc();
extern int twiddle();
extern int typahead();
extern int unarg();
extern int unbindchar();
extern int unbindkey();
extern int undent_region();
extern int unmark();
extern int upperregion();
extern int upperword();
extern int usebuffer();
extern int viewfile();
extern int vteeol();
extern int vtmove();
extern int vtputc();
extern int vttidy();
extern int widen();
extern int wordcount();
extern int wrapword();
extern int writemsg();
extern int writeout();
extern int zotbuf();
extern unsigned int chcase();
extern unsigned int getckey();
extern unsigned int stock();
extern void mlwrite();
extern void crypt();
extern void errormesg();
extern void flong_asc();
extern void freewhile();
extern void getdtime();
extern void initchars();
extern void kdelete();
extern void lowercase();
extern void makelit();
extern void mcclear();
extern void mlabort();
extern void mlerase();
extern void mlferase();
extern void mlforce();
extern void mlout();
extern void mlputf();
extern void mlputi();
extern void mlputli();
extern void mlputs();
extern void mlrquery();
extern void modeline();
extern void movecursor();
extern void next_kill();
extern void pad();
extern void reeat();
extern void reframe();
extern void rmcclear();
extern void setbit();
extern void setjtable();
extern void unqname();
extern void updall();
extern void update();
extern void update_size();
extern void upddex();
extern void updext();
extern void updgar();
extern void updone();
extern void updpos();
extern void upmode();
extern void updupd();
extern void uppercase();
extern void upwind();
extern void varinit();
extern void varclean();
extern void vtfree();
extern WINDOW *mousewindow();
extern int wpopup();

#if	CTAGS
extern int tagword();	/* vi-like tagging */
extern int retagword();	/* Try again (if redefined) */
extern int backtagword();	/* return from tagged word */

#endif

#if LINE_FNS
extern int copyline();
extern int kill_line();
extern int openabove();

#endif

/* some library redefinitions */

char *strrev();

#ifndef __STDC__
extern char *strcat();
extern char *strcpy();
extern char *strchr();

#if RAMSIZE == 0
extern char *malloc();
extern VOID free();
#endif

extern char *realloc();

#endif /* __STDC__ */


#if UNDOCMD
extern int  undump();
extern int  undebug();
extern int  undo();
extern int  undo_finished();
extern int  undo_gotomark();
extern int  undo_linsert();
extern int  undo_newline();
extern int  fix_undo_struct();
extern int  undo_ldelete();
extern int  undo_save_ldelete();
extern int  undo_ifile();
extern int  undo_save_dot();
extern int  undo_save_fn();
#endif

#endif
